<% @ Language=VBScript %>
<% Option Explicit %>
<%
'#############################################
'Routines per la connessione al DB 
'e l'inizializzazione dell'applicazione
'Autore: Luca Milan - info@lucamilan.it
'Prodotto per FreeASP
'#############################################
	
	Response.Buffer = true
	Session.LCID = "1040"	
	
	'---- CursorLocationEnum Values ----
	Const adUseClient = 3
	'---- CommandTypeEnum Values ----
	Const adCmdStoredProc = &H0004
	'---- ObjectStateEnum Values ----
	Const adStateClosed = &H00000000
	Const adStateOpen = &H00000001

	
	
	'Dimensiono tutte le variabili
	Dim sADOConStr 'stringa connessione
	Dim oADOCon, oADORec, oADOCom 'oggetti ADO
	Dim id, username, password, errore, numvisite, giornirimasti, retval 'prm i/o della stored proc
	Dim ret, coderr 'gestione degli errori
	Dim arrUtenti, arrStats
	
	
'stringa di connessione al database, ovviamente dovete sostituire i parametri
'con quelli del vostro SQL SERVER
	sADOConStr = "Provider=SQLOLEDB;Data Source=(local)\LUCA2000;" &_
				  "User ID=sa;Password=caffenograzie;Initial Catalog=FreeASP"
	
	Set oADOCon = Server.CreateObject("ADODB.Connection")
	Set oADORec = Server.CreateObject("ADODB.RecordSet")
   	Set oADOCom = Server.CreateObject("ADODB.Command")
			  
    oADOCon.CursorLocation = adUseClient
    oADOCon.open sADOConStr

Sub Login()	
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_Login"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	oADOCom.Parameters(1) = username 'prm di Input
	oADOCom.Parameters(2) = password 'prm di Input
	oADOCom.Parameters(3) = NULL 'prm di i/o passo un valore null inizialmente
	oADOCom.Parameters(4) = NULL 'prm di i/o passo un valore null inizialmente
	oADOCom.Parameters(5) = NULL 'prm di i/o passo un valore null inizialmente
	oADOCom.Execute 	
	retval = oADOCom.Parameters(0)
	errore = oADOCom.Parameters(3)
	numvisite = oADOCom.Parameters(4)
	giornirimasti = oADOCom.Parameters(5)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If		
End Sub				  

Sub SelUtenti()	
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_Sel_Utenti"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	Set oADORec = oADOCom.Execute
	If NOT oADORec.EOF Then
		arrUtenti = oADORec.GetRows
	Else
		arrUtenti = Null
	End If
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If		
End Sub	

Sub UpdUtenti()
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_Upd_Utenti"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	oADOCom.Parameters(1) = id 'prm di Input
	oADOCom.Parameters(2) = username 'prm di Input
	oADOCom.Parameters(3) = password 'prm di Input
	oADOCom.Parameters(4) = numvisite 'prm di i/o passo un valore null inizialmente
	oADOCom.Parameters(5) = giornirimasti 'prm di i/o passo un valore null inizialmente
	oADOCom.Execute 	
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If	
End Sub

Sub DelUtenti()
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_Del_Utenti"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	oADOCom.Parameters(1) = id 'prm di Input
	oADOCom.Execute 	
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If		
End Sub

Sub InsUtenti()
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_Ins_Utenti"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	oADOCom.Parameters(1) = username 'prm di Input
	oADOCom.Parameters(2) = password 'prm di Input
	oADOCom.Execute 	
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If	
End Sub


Sub AttDisUtenti( azione, uid )	
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_DisAtt_Utenti"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	oADOCom.Parameters(1) = azione 'prm di Input
	oADOCom.Parameters(2) = uid 'prm di Input
	oADOCom.Execute
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If	
End Sub	

Sub SelStats()	
On Error Resume Next
	oADOCom.activeconnection = oADOCon
	oADOCom.commandtext = "P_DammiStats"
	oADOCom.commandtype = adCmdStoredProc
	oADOCom.Parameters.Refresh	
	Set oADORec = oADOCom.Execute
	If NOT oADORec.EOF Then
		arrStats = oADORec.GetRows
	Else
		arrStats = Null
	End If
	retval = oADOCom.Parameters(0)
	If err Then 
		Call ErroriUtenti( err.number, err.description )
	End If		
End Sub	

Sub ErroriUtenti( num, desc )
	Select Case num
	Case -2147217873
	Response.Write "<B>Errore:</B> " & _
					"Non e' possibile inserire una login " & _
					"(username, password)" & _
					" gia' esistente!" & _
					" >> " & username & " >> " & password & _
					"<br>"
	Case -2147217904
	Response.Write "<B>Errore:</B> " & _
					"Hai dimenticato di inserire un parametro" & _
					"<br>"				
	Case Else
	Response.Write "<B>Errore numero:</B> " & err.number & "<br>"
	Response.Write "<B>Descrizione:</B> " & err.description & ""	
	End Select
End Sub


%>
